/**
 * This class file was automatically generated by jASN1 v1.5.1-SNAPSHOT (http://www.openmuc.org)
 */

package org.openmuc.openiec61850.internal.mms.asn1;

import java.io.IOException;
import java.io.InputStream;

import org.openmuc.jasn1.ber.BerByteArrayOutputStream;
import org.openmuc.jasn1.ber.BerIdentifier;
import org.openmuc.jasn1.ber.BerLength;
import org.openmuc.jasn1.ber.types.BerNull;

public class GetNameListRequest {

    public static class SubChoice_objectScope {

        public byte[] code = null;
        public BerNull vmdSpecific = null;

        public Identifier domainSpecific = null;

        public BerNull aaSpecific = null;

        public SubChoice_objectScope() {
        }

        public SubChoice_objectScope(byte[] code) {
            this.code = code;
        }

        public SubChoice_objectScope(BerNull vmdSpecific, Identifier domainSpecific, BerNull aaSpecific) {
            this.vmdSpecific = vmdSpecific;
            this.domainSpecific = domainSpecific;
            this.aaSpecific = aaSpecific;
        }

        public int encode(BerByteArrayOutputStream os, boolean explicit) throws IOException {
            if (code != null) {
                for (int i = code.length - 1; i >= 0; i--) {
                    os.write(code[i]);
                }
                return code.length;

            }
            int codeLength = 0;
            if (aaSpecific != null) {
                codeLength += aaSpecific.encode(os, false);
                // write tag: CONTEXT_CLASS, PRIMITIVE, 2
                os.write(0x82);
                codeLength += 1;
                return codeLength;

            }

            if (domainSpecific != null) {
                codeLength += domainSpecific.encode(os, false);
                // write tag: CONTEXT_CLASS, PRIMITIVE, 1
                os.write(0x81);
                codeLength += 1;
                return codeLength;

            }

            if (vmdSpecific != null) {
                codeLength += vmdSpecific.encode(os, false);
                // write tag: CONTEXT_CLASS, PRIMITIVE, 0
                os.write(0x80);
                codeLength += 1;
                return codeLength;

            }

            throw new IOException("Error encoding BerChoice: No item in choice was selected.");
        }

        public int decode(InputStream is, BerIdentifier berIdentifier) throws IOException {
            int codeLength = 0;
            BerIdentifier passedIdentifier = berIdentifier;

            if (berIdentifier == null) {
                berIdentifier = new BerIdentifier();
                codeLength += berIdentifier.decode(is);
            }
            if (berIdentifier.equals(BerIdentifier.CONTEXT_CLASS, BerIdentifier.PRIMITIVE, 0)) {
                vmdSpecific = new BerNull();
                codeLength += vmdSpecific.decode(is, false);
                return codeLength;
            }

            if (berIdentifier.equals(BerIdentifier.CONTEXT_CLASS, BerIdentifier.PRIMITIVE, 1)) {
                domainSpecific = new Identifier();
                codeLength += domainSpecific.decode(is, false);
                return codeLength;
            }

            if (berIdentifier.equals(BerIdentifier.CONTEXT_CLASS, BerIdentifier.PRIMITIVE, 2)) {
                aaSpecific = new BerNull();
                codeLength += aaSpecific.decode(is, false);
                return codeLength;
            }

            if (passedIdentifier != null) {
                return 0;
            }
            throw new IOException("Error decoding BerChoice: Identifier matched to no item.");
        }

        public void encodeAndSave(int encodingSizeGuess) throws IOException {
            BerByteArrayOutputStream os = new BerByteArrayOutputStream(encodingSizeGuess);
            encode(os, false);
            code = os.getArray();
        }

        @Override
        public String toString() {
            if (vmdSpecific != null) {
                return "CHOICE{vmdSpecific: " + vmdSpecific + "}";
            }

            if (domainSpecific != null) {
                return "CHOICE{domainSpecific: " + domainSpecific + "}";
            }

            if (aaSpecific != null) {
                return "CHOICE{aaSpecific: " + aaSpecific + "}";
            }

            return "unknown";
        }

    }

    public static final BerIdentifier identifier = new BerIdentifier(BerIdentifier.UNIVERSAL_CLASS,
            BerIdentifier.CONSTRUCTED, 16);
    protected BerIdentifier id;

    public byte[] code = null;
    public ObjectClass objectClass = null;

    public SubChoice_objectScope objectScope = null;

    public Identifier continueAfter = null;

    public GetNameListRequest() {
        id = identifier;
    }

    public GetNameListRequest(byte[] code) {
        id = identifier;
        this.code = code;
    }

    public GetNameListRequest(ObjectClass objectClass, SubChoice_objectScope objectScope, Identifier continueAfter) {
        id = identifier;
        this.objectClass = objectClass;
        this.objectScope = objectScope;
        this.continueAfter = continueAfter;
    }

    public int encode(BerByteArrayOutputStream os, boolean explicit) throws IOException {

        int codeLength;

        if (code != null) {
            codeLength = code.length;
            for (int i = code.length - 1; i >= 0; i--) {
                os.write(code[i]);
            }
        }
        else {
            codeLength = 0;
            int sublength;

            if (continueAfter != null) {
                codeLength += continueAfter.encode(os, false);
                // write tag: CONTEXT_CLASS, PRIMITIVE, 2
                os.write(0x82);
                codeLength += 1;
            }

            sublength = objectScope.encode(os, true);
            codeLength += sublength;
            codeLength += BerLength.encodeLength(os, sublength);
            // write tag: CONTEXT_CLASS, CONSTRUCTED, 1
            os.write(0xa1);
            codeLength += 1;

            sublength = objectClass.encode(os, true);
            codeLength += sublength;
            codeLength += BerLength.encodeLength(os, sublength);
            // write tag: CONTEXT_CLASS, CONSTRUCTED, 0
            os.write(0xa0);
            codeLength += 1;

            codeLength += BerLength.encodeLength(os, codeLength);
        }

        if (explicit) {
            codeLength += id.encode(os);
        }

        return codeLength;

    }

    public int decode(InputStream is, boolean explicit) throws IOException {
        int codeLength = 0;
        int subCodeLength = 0;
        BerIdentifier berIdentifier = new BerIdentifier();

        if (explicit) {
            codeLength += id.decodeAndCheck(is);
        }

        BerLength length = new BerLength();
        codeLength += length.decode(is);

        codeLength += length.val;

        subCodeLength += berIdentifier.decode(is);
        if (berIdentifier.equals(BerIdentifier.CONTEXT_CLASS, BerIdentifier.CONSTRUCTED, 0)) {
            subCodeLength += new BerLength().decode(is);
            objectClass = new ObjectClass();
            subCodeLength += objectClass.decode(is, null);
            subCodeLength += berIdentifier.decode(is);
        }
        else {
            throw new IOException("Identifier does not match required sequence element identifer.");
        }

        if (berIdentifier.equals(BerIdentifier.CONTEXT_CLASS, BerIdentifier.CONSTRUCTED, 1)) {
            subCodeLength += new BerLength().decode(is);
            objectScope = new SubChoice_objectScope();
            subCodeLength += objectScope.decode(is, null);
            if (subCodeLength == length.val) {
                return codeLength;
            }
            subCodeLength += berIdentifier.decode(is);
        }
        else {
            throw new IOException("Identifier does not match required sequence element identifer.");
        }

        if (berIdentifier.equals(BerIdentifier.CONTEXT_CLASS, BerIdentifier.PRIMITIVE, 2)) {
            continueAfter = new Identifier();
            subCodeLength += continueAfter.decode(is, false);
            if (subCodeLength == length.val) {
                return codeLength;
            }
        }
        throw new IOException(
                "Unexpected end of sequence, length tag: " + length.val + ", actual sequence length: " + subCodeLength);

    }

    public void encodeAndSave(int encodingSizeGuess) throws IOException {
        BerByteArrayOutputStream os = new BerByteArrayOutputStream(encodingSizeGuess);
        encode(os, false);
        code = os.getArray();
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder("SEQUENCE{");
        sb.append("objectClass: ").append(objectClass);

        sb.append(", ");
        sb.append("objectScope: ").append(objectScope);

        if (continueAfter != null) {
            sb.append(", ");
            sb.append("continueAfter: ").append(continueAfter);
        }

        sb.append("}");
        return sb.toString();
    }

}
