/**
 * This class file was automatically generated by jASN1 v1.5.1-SNAPSHOT (http://www.openmuc.org)
 */

package org.openmuc.openiec61850.internal.mms.asn1;

import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.openmuc.jasn1.ber.BerByteArrayOutputStream;
import org.openmuc.jasn1.ber.BerIdentifier;
import org.openmuc.jasn1.ber.BerLength;
import org.openmuc.jasn1.ber.types.BerBoolean;

public class GetNameListResponse {

    public static class SubSeqOf_listOfIdentifier {

        public static final BerIdentifier identifier = new BerIdentifier(BerIdentifier.UNIVERSAL_CLASS,
                BerIdentifier.CONSTRUCTED, 16);
        protected BerIdentifier id;

        public byte[] code = null;
        public List<Identifier> seqOf = null;

        public SubSeqOf_listOfIdentifier() {
            id = identifier;
            seqOf = new ArrayList<Identifier>();
        }

        public SubSeqOf_listOfIdentifier(byte[] code) {
            id = identifier;
            this.code = code;
        }

        public SubSeqOf_listOfIdentifier(List<Identifier> seqOf) {
            id = identifier;
            this.seqOf = seqOf;
        }

        public int encode(BerByteArrayOutputStream os, boolean explicit) throws IOException {
            int codeLength;

            if (code != null) {
                codeLength = code.length;
                for (int i = code.length - 1; i >= 0; i--) {
                    os.write(code[i]);
                }
            }
            else {
                codeLength = 0;
                for (int i = (seqOf.size() - 1); i >= 0; i--) {
                    codeLength += seqOf.get(i).encode(os, true);
                }

                codeLength += BerLength.encodeLength(os, codeLength);

            }

            if (explicit) {
                codeLength += id.encode(os);
            }

            return codeLength;
        }

        public int decode(InputStream is, boolean explicit) throws IOException {
            int codeLength = 0;
            int subCodeLength = 0;
            if (explicit) {
                codeLength += id.decodeAndCheck(is);
            }

            BerLength length = new BerLength();
            codeLength += length.decode(is);

            while (subCodeLength < length.val) {
                Identifier element = new Identifier();
                subCodeLength += element.decode(is, true);
                seqOf.add(element);
            }
            if (subCodeLength != length.val) {
                throw new IOException("Decoded SequenceOf or SetOf has wrong length tag");

            }
            codeLength += subCodeLength;

            return codeLength;
        }

        public void encodeAndSave(int encodingSizeGuess) throws IOException {
            BerByteArrayOutputStream os = new BerByteArrayOutputStream(encodingSizeGuess);
            encode(os, false);
            code = os.getArray();
        }

        @Override
        public String toString() {
            StringBuilder sb = new StringBuilder("SEQUENCE OF{");

            if (seqOf == null) {
                sb.append("null");
            }
            else {
                Iterator<Identifier> it = seqOf.iterator();
                if (it.hasNext()) {
                    sb.append(it.next());
                    while (it.hasNext()) {
                        sb.append(", ").append(it.next());
                    }
                }
            }

            sb.append("}");

            return sb.toString();
        }

    }

    public static final BerIdentifier identifier = new BerIdentifier(BerIdentifier.UNIVERSAL_CLASS,
            BerIdentifier.CONSTRUCTED, 16);
    protected BerIdentifier id;

    public byte[] code = null;
    public SubSeqOf_listOfIdentifier listOfIdentifier = null;

    public BerBoolean moreFollows = null;

    public GetNameListResponse() {
        id = identifier;
    }

    public GetNameListResponse(byte[] code) {
        id = identifier;
        this.code = code;
    }

    public GetNameListResponse(SubSeqOf_listOfIdentifier listOfIdentifier, BerBoolean moreFollows) {
        id = identifier;
        this.listOfIdentifier = listOfIdentifier;
        this.moreFollows = moreFollows;
    }

    public int encode(BerByteArrayOutputStream os, boolean explicit) throws IOException {

        int codeLength;

        if (code != null) {
            codeLength = code.length;
            for (int i = code.length - 1; i >= 0; i--) {
                os.write(code[i]);
            }
        }
        else {
            codeLength = 0;
            if (moreFollows != null) {
                codeLength += moreFollows.encode(os, false);
                // write tag: CONTEXT_CLASS, PRIMITIVE, 1
                os.write(0x81);
                codeLength += 1;
            }

            codeLength += listOfIdentifier.encode(os, false);
            // write tag: CONTEXT_CLASS, CONSTRUCTED, 0
            os.write(0xa0);
            codeLength += 1;

            codeLength += BerLength.encodeLength(os, codeLength);
        }

        if (explicit) {
            codeLength += id.encode(os);
        }

        return codeLength;

    }

    public int decode(InputStream is, boolean explicit) throws IOException {
        int codeLength = 0;
        int subCodeLength = 0;
        BerIdentifier berIdentifier = new BerIdentifier();

        if (explicit) {
            codeLength += id.decodeAndCheck(is);
        }

        BerLength length = new BerLength();
        codeLength += length.decode(is);

        codeLength += length.val;

        subCodeLength += berIdentifier.decode(is);
        if (berIdentifier.equals(BerIdentifier.CONTEXT_CLASS, BerIdentifier.CONSTRUCTED, 0)) {
            listOfIdentifier = new SubSeqOf_listOfIdentifier();
            subCodeLength += listOfIdentifier.decode(is, false);
            if (subCodeLength == length.val) {
                return codeLength;
            }
            subCodeLength += berIdentifier.decode(is);
        }
        else {
            throw new IOException("Identifier does not match the mandatory sequence element identifer.");
        }

        if (berIdentifier.equals(BerIdentifier.CONTEXT_CLASS, BerIdentifier.PRIMITIVE, 1)) {
            moreFollows = new BerBoolean();
            subCodeLength += moreFollows.decode(is, false);
            if (subCodeLength == length.val) {
                return codeLength;
            }
        }
        throw new IOException(
                "Unexpected end of sequence, length tag: " + length.val + ", actual sequence length: " + subCodeLength);

    }

    public void encodeAndSave(int encodingSizeGuess) throws IOException {
        BerByteArrayOutputStream os = new BerByteArrayOutputStream(encodingSizeGuess);
        encode(os, false);
        code = os.getArray();
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder("SEQUENCE{");
        sb.append("listOfIdentifier: ").append(listOfIdentifier);

        if (moreFollows != null) {
            sb.append(", ");
            sb.append("moreFollows: ").append(moreFollows);
        }

        sb.append("}");
        return sb.toString();
    }

}
