/**
 * This class file was automatically generated by jASN1 v1.5.1-SNAPSHOT (http://www.openmuc.org)
 */

package org.openmuc.openiec61850.internal.mms.asn1;

import java.io.IOException;
import java.io.InputStream;

import org.openmuc.jasn1.ber.BerByteArrayOutputStream;
import org.openmuc.jasn1.ber.BerIdentifier;
import org.openmuc.jasn1.ber.BerLength;
import org.openmuc.jasn1.ber.types.string.BerVisibleString;

public class ObjectName {

    public byte[] code = null;

    public static class SubSeq_domainSpecific {

        public static final BerIdentifier identifier = new BerIdentifier(BerIdentifier.UNIVERSAL_CLASS,
                BerIdentifier.CONSTRUCTED, 16);
        protected BerIdentifier id;

        public byte[] code = null;
        public Identifier domainID = null;

        public Identifier itemID = null;

        public SubSeq_domainSpecific() {
            id = identifier;
        }

        public SubSeq_domainSpecific(byte[] code) {
            id = identifier;
            this.code = code;
        }

        public SubSeq_domainSpecific(Identifier domainID, Identifier itemID) {
            id = identifier;
            this.domainID = domainID;
            this.itemID = itemID;
        }

        public int encode(BerByteArrayOutputStream os, boolean explicit) throws IOException {

            int codeLength;

            if (code != null) {
                codeLength = code.length;
                for (int i = code.length - 1; i >= 0; i--) {
                    os.write(code[i]);
                }
            }
            else {
                codeLength = 0;
                codeLength += itemID.encode(os, true);

                codeLength += domainID.encode(os, true);

                codeLength += BerLength.encodeLength(os, codeLength);
            }

            if (explicit) {
                codeLength += id.encode(os);
            }

            return codeLength;

        }

        public int decode(InputStream is, boolean explicit) throws IOException {
            int codeLength = 0;
            int subCodeLength = 0;
            BerIdentifier berIdentifier = new BerIdentifier();

            if (explicit) {
                codeLength += id.decodeAndCheck(is);
            }

            BerLength length = new BerLength();
            codeLength += length.decode(is);

            codeLength += length.val;

            subCodeLength += berIdentifier.decode(is);
            if (berIdentifier.equals(BerVisibleString.identifier)) {
                domainID = new Identifier();
                subCodeLength += domainID.decode(is, false);
                subCodeLength += berIdentifier.decode(is);
            }
            else {
                throw new IOException("Identifier does not match the mandatory sequence element identifer.");
            }

            if (berIdentifier.equals(BerVisibleString.identifier)) {
                itemID = new Identifier();
                subCodeLength += itemID.decode(is, false);
                if (subCodeLength == length.val) {
                    return codeLength;
                }
            }
            throw new IOException("Unexpected end of sequence, length tag: " + length.val + ", actual sequence length: "
                    + subCodeLength);

        }

        public void encodeAndSave(int encodingSizeGuess) throws IOException {
            BerByteArrayOutputStream os = new BerByteArrayOutputStream(encodingSizeGuess);
            encode(os, false);
            code = os.getArray();
        }

        @Override
        public String toString() {
            StringBuilder sb = new StringBuilder("SEQUENCE{");
            sb.append("domainID: ").append(domainID);

            sb.append(", ");
            sb.append("itemID: ").append(itemID);

            sb.append("}");
            return sb.toString();
        }

    }

    public Identifier vmdSpecific = null;

    public SubSeq_domainSpecific domainSpecific = null;

    public Identifier aaSpecific = null;

    public ObjectName() {
    }

    public ObjectName(byte[] code) {
        this.code = code;
    }

    public ObjectName(Identifier vmdSpecific, SubSeq_domainSpecific domainSpecific, Identifier aaSpecific) {
        this.vmdSpecific = vmdSpecific;
        this.domainSpecific = domainSpecific;
        this.aaSpecific = aaSpecific;
    }

    public int encode(BerByteArrayOutputStream os, boolean explicit) throws IOException {
        if (code != null) {
            for (int i = code.length - 1; i >= 0; i--) {
                os.write(code[i]);
            }
            return code.length;

        }
        int codeLength = 0;
        if (aaSpecific != null) {
            codeLength += aaSpecific.encode(os, false);
            // write tag: CONTEXT_CLASS, PRIMITIVE, 2
            os.write(0x82);
            codeLength += 1;
            return codeLength;

        }

        if (domainSpecific != null) {
            codeLength += domainSpecific.encode(os, false);
            // write tag: CONTEXT_CLASS, CONSTRUCTED, 1
            os.write(0xa1);
            codeLength += 1;
            return codeLength;

        }

        if (vmdSpecific != null) {
            codeLength += vmdSpecific.encode(os, false);
            // write tag: CONTEXT_CLASS, PRIMITIVE, 0
            os.write(0x80);
            codeLength += 1;
            return codeLength;

        }

        throw new IOException("Error encoding BerChoice: No item in choice was selected.");
    }

    public int decode(InputStream is, BerIdentifier berIdentifier) throws IOException {
        int codeLength = 0;
        BerIdentifier passedIdentifier = berIdentifier;

        if (berIdentifier == null) {
            berIdentifier = new BerIdentifier();
            codeLength += berIdentifier.decode(is);
        }
        if (berIdentifier.equals(BerIdentifier.CONTEXT_CLASS, BerIdentifier.PRIMITIVE, 0)) {
            vmdSpecific = new Identifier();
            codeLength += vmdSpecific.decode(is, false);
            return codeLength;
        }

        if (berIdentifier.equals(BerIdentifier.CONTEXT_CLASS, BerIdentifier.CONSTRUCTED, 1)) {
            domainSpecific = new SubSeq_domainSpecific();
            codeLength += domainSpecific.decode(is, false);
            return codeLength;
        }

        if (berIdentifier.equals(BerIdentifier.CONTEXT_CLASS, BerIdentifier.PRIMITIVE, 2)) {
            aaSpecific = new Identifier();
            codeLength += aaSpecific.decode(is, false);
            return codeLength;
        }

        if (passedIdentifier != null) {
            return 0;
        }
        throw new IOException("Error decoding BerChoice: Identifier matched to no item.");
    }

    public void encodeAndSave(int encodingSizeGuess) throws IOException {
        BerByteArrayOutputStream os = new BerByteArrayOutputStream(encodingSizeGuess);
        encode(os, false);
        code = os.getArray();
    }

    @Override
    public String toString() {
        if (vmdSpecific != null) {
            return "CHOICE{vmdSpecific: " + vmdSpecific + "}";
        }

        if (domainSpecific != null) {
            return "CHOICE{domainSpecific: " + domainSpecific + "}";
        }

        if (aaSpecific != null) {
            return "CHOICE{aaSpecific: " + aaSpecific + "}";
        }

        return "unknown";
    }

}
