/**
 * This class file was automatically generated by jASN1 v1.5.1-SNAPSHOT (http://www.openmuc.org)
 */

package org.openmuc.openiec61850.internal.mms.asn1;

import java.io.IOException;
import java.io.InputStream;

import org.openmuc.jasn1.ber.BerByteArrayOutputStream;
import org.openmuc.jasn1.ber.BerIdentifier;
import org.openmuc.jasn1.ber.BerLength;
import org.openmuc.jasn1.ber.types.BerBoolean;

public class ReadRequest {

    public static final BerIdentifier identifier = new BerIdentifier(BerIdentifier.UNIVERSAL_CLASS,
            BerIdentifier.CONSTRUCTED, 16);
    protected BerIdentifier id;

    public byte[] code = null;
    public BerBoolean specificationWithResult = null;

    public VariableAccessSpecification variableAccessSpecification = null;

    public ReadRequest() {
        id = identifier;
    }

    public ReadRequest(byte[] code) {
        id = identifier;
        this.code = code;
    }

    public ReadRequest(BerBoolean specificationWithResult, VariableAccessSpecification variableAccessSpecification) {
        id = identifier;
        this.specificationWithResult = specificationWithResult;
        this.variableAccessSpecification = variableAccessSpecification;
    }

    public int encode(BerByteArrayOutputStream os, boolean explicit) throws IOException {

        int codeLength;

        if (code != null) {
            codeLength = code.length;
            for (int i = code.length - 1; i >= 0; i--) {
                os.write(code[i]);
            }
        }
        else {
            codeLength = 0;
            int sublength;

            sublength = variableAccessSpecification.encode(os, true);
            codeLength += sublength;
            codeLength += BerLength.encodeLength(os, sublength);
            // write tag: CONTEXT_CLASS, CONSTRUCTED, 1
            os.write(0xa1);
            codeLength += 1;

            if (specificationWithResult != null) {
                codeLength += specificationWithResult.encode(os, false);
                // write tag: CONTEXT_CLASS, PRIMITIVE, 0
                os.write(0x80);
                codeLength += 1;
            }

            codeLength += BerLength.encodeLength(os, codeLength);
        }

        if (explicit) {
            codeLength += id.encode(os);
        }

        return codeLength;

    }

    public int decode(InputStream is, boolean explicit) throws IOException {
        int codeLength = 0;
        int subCodeLength = 0;
        BerIdentifier berIdentifier = new BerIdentifier();

        if (explicit) {
            codeLength += id.decodeAndCheck(is);
        }

        BerLength length = new BerLength();
        codeLength += length.decode(is);

        codeLength += length.val;

        subCodeLength += berIdentifier.decode(is);
        if (berIdentifier.equals(BerIdentifier.CONTEXT_CLASS, BerIdentifier.PRIMITIVE, 0)) {
            specificationWithResult = new BerBoolean();
            subCodeLength += specificationWithResult.decode(is, false);
            subCodeLength += berIdentifier.decode(is);
        }

        if (berIdentifier.equals(BerIdentifier.CONTEXT_CLASS, BerIdentifier.CONSTRUCTED, 1)) {
            subCodeLength += new BerLength().decode(is);
            variableAccessSpecification = new VariableAccessSpecification();
            subCodeLength += variableAccessSpecification.decode(is, null);
            if (subCodeLength == length.val) {
                return codeLength;
            }
        }
        throw new IOException(
                "Unexpected end of sequence, length tag: " + length.val + ", actual sequence length: " + subCodeLength);

    }

    public void encodeAndSave(int encodingSizeGuess) throws IOException {
        BerByteArrayOutputStream os = new BerByteArrayOutputStream(encodingSizeGuess);
        encode(os, false);
        code = os.getArray();
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder("SEQUENCE{");
        boolean firstSelectedElement = true;
        if (specificationWithResult != null) {
            sb.append("specificationWithResult: ").append(specificationWithResult);
            firstSelectedElement = false;
        }

        if (!firstSelectedElement) {
            sb.append(", ");
        }
        sb.append("variableAccessSpecification: ").append(variableAccessSpecification);

        sb.append("}");
        return sb.toString();
    }

}
