/**
 * This class file was automatically generated by jASN1 v1.5.1-SNAPSHOT (http://www.openmuc.org)
 */

package org.openmuc.openiec61850.internal.mms.asn1;

import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.openmuc.jasn1.ber.BerByteArrayOutputStream;
import org.openmuc.jasn1.ber.BerIdentifier;
import org.openmuc.jasn1.ber.BerLength;
import org.openmuc.jasn1.ber.types.BerBoolean;
import org.openmuc.jasn1.ber.types.BerInteger;
import org.openmuc.jasn1.ber.types.BerNull;

public class TypeDescription {

    public byte[] code = null;

    public static class SubSeq_array {

        public static final BerIdentifier identifier = new BerIdentifier(BerIdentifier.UNIVERSAL_CLASS,
                BerIdentifier.CONSTRUCTED, 16);
        protected BerIdentifier id;

        public byte[] code = null;
        public BerBoolean packed = null;

        public Unsigned32 numberOfElements = null;

        public TypeSpecification elementType = null;

        public SubSeq_array() {
            id = identifier;
        }

        public SubSeq_array(byte[] code) {
            id = identifier;
            this.code = code;
        }

        public SubSeq_array(BerBoolean packed, Unsigned32 numberOfElements, TypeSpecification elementType) {
            id = identifier;
            this.packed = packed;
            this.numberOfElements = numberOfElements;
            this.elementType = elementType;
        }

        public int encode(BerByteArrayOutputStream os, boolean explicit) throws IOException {

            int codeLength;

            if (code != null) {
                codeLength = code.length;
                for (int i = code.length - 1; i >= 0; i--) {
                    os.write(code[i]);
                }
            }
            else {
                codeLength = 0;
                int sublength;

                sublength = elementType.encode(os, true);
                codeLength += sublength;
                codeLength += BerLength.encodeLength(os, sublength);
                // write tag: CONTEXT_CLASS, CONSTRUCTED, 2
                os.write(0xa2);
                codeLength += 1;

                codeLength += numberOfElements.encode(os, false);
                // write tag: CONTEXT_CLASS, PRIMITIVE, 1
                os.write(0x81);
                codeLength += 1;

                if (packed != null) {
                    codeLength += packed.encode(os, false);
                    // write tag: CONTEXT_CLASS, PRIMITIVE, 0
                    os.write(0x80);
                    codeLength += 1;
                }

                codeLength += BerLength.encodeLength(os, codeLength);
            }

            if (explicit) {
                codeLength += id.encode(os);
            }

            return codeLength;

        }

        public int decode(InputStream is, boolean explicit) throws IOException {
            int codeLength = 0;
            int subCodeLength = 0;
            BerIdentifier berIdentifier = new BerIdentifier();

            if (explicit) {
                codeLength += id.decodeAndCheck(is);
            }

            BerLength length = new BerLength();
            codeLength += length.decode(is);

            codeLength += length.val;

            subCodeLength += berIdentifier.decode(is);
            if (berIdentifier.equals(BerIdentifier.CONTEXT_CLASS, BerIdentifier.PRIMITIVE, 0)) {
                packed = new BerBoolean();
                subCodeLength += packed.decode(is, false);
                subCodeLength += berIdentifier.decode(is);
            }

            if (berIdentifier.equals(BerIdentifier.CONTEXT_CLASS, BerIdentifier.PRIMITIVE, 1)) {
                numberOfElements = new Unsigned32();
                subCodeLength += numberOfElements.decode(is, false);
                subCodeLength += berIdentifier.decode(is);
            }
            else {
                throw new IOException("Identifier does not match the mandatory sequence element identifer.");
            }

            if (berIdentifier.equals(BerIdentifier.CONTEXT_CLASS, BerIdentifier.CONSTRUCTED, 2)) {
                subCodeLength += new BerLength().decode(is);
                elementType = new TypeSpecification();
                subCodeLength += elementType.decode(is, null);
                if (subCodeLength == length.val) {
                    return codeLength;
                }
            }
            throw new IOException("Unexpected end of sequence, length tag: " + length.val + ", actual sequence length: "
                    + subCodeLength);

        }

        public void encodeAndSave(int encodingSizeGuess) throws IOException {
            BerByteArrayOutputStream os = new BerByteArrayOutputStream(encodingSizeGuess);
            encode(os, false);
            code = os.getArray();
        }

        @Override
        public String toString() {
            StringBuilder sb = new StringBuilder("SEQUENCE{");
            boolean firstSelectedElement = true;
            if (packed != null) {
                sb.append("packed: ").append(packed);
                firstSelectedElement = false;
            }

            if (!firstSelectedElement) {
                sb.append(", ");
            }
            sb.append("numberOfElements: ").append(numberOfElements);

            sb.append(", ");
            sb.append("elementType: ").append(elementType);

            sb.append("}");
            return sb.toString();
        }

    }

    public static class SubSeq_structure {

        public static class SubSeqOf_components {

            public static class SubSeq {

                public static final BerIdentifier identifier = new BerIdentifier(BerIdentifier.UNIVERSAL_CLASS,
                        BerIdentifier.CONSTRUCTED, 16);
                protected BerIdentifier id;

                public byte[] code = null;
                public Identifier componentName = null;

                public TypeSpecification componentType = null;

                public SubSeq() {
                    id = identifier;
                }

                public SubSeq(byte[] code) {
                    id = identifier;
                    this.code = code;
                }

                public SubSeq(Identifier componentName, TypeSpecification componentType) {
                    id = identifier;
                    this.componentName = componentName;
                    this.componentType = componentType;
                }

                public int encode(BerByteArrayOutputStream os, boolean explicit) throws IOException {

                    int codeLength;

                    if (code != null) {
                        codeLength = code.length;
                        for (int i = code.length - 1; i >= 0; i--) {
                            os.write(code[i]);
                        }
                    }
                    else {
                        codeLength = 0;
                        int sublength;

                        sublength = componentType.encode(os, true);
                        codeLength += sublength;
                        codeLength += BerLength.encodeLength(os, sublength);
                        // write tag: CONTEXT_CLASS, CONSTRUCTED, 1
                        os.write(0xa1);
                        codeLength += 1;

                        if (componentName != null) {
                            codeLength += componentName.encode(os, false);
                            // write tag: CONTEXT_CLASS, PRIMITIVE, 0
                            os.write(0x80);
                            codeLength += 1;
                        }

                        codeLength += BerLength.encodeLength(os, codeLength);
                    }

                    if (explicit) {
                        codeLength += id.encode(os);
                    }

                    return codeLength;

                }

                public int decode(InputStream is, boolean explicit) throws IOException {
                    int codeLength = 0;
                    int subCodeLength = 0;
                    BerIdentifier berIdentifier = new BerIdentifier();

                    if (explicit) {
                        codeLength += id.decodeAndCheck(is);
                    }

                    BerLength length = new BerLength();
                    codeLength += length.decode(is);

                    codeLength += length.val;

                    subCodeLength += berIdentifier.decode(is);
                    if (berIdentifier.equals(BerIdentifier.CONTEXT_CLASS, BerIdentifier.PRIMITIVE, 0)) {
                        componentName = new Identifier();
                        subCodeLength += componentName.decode(is, false);
                        subCodeLength += berIdentifier.decode(is);
                    }

                    if (berIdentifier.equals(BerIdentifier.CONTEXT_CLASS, BerIdentifier.CONSTRUCTED, 1)) {
                        subCodeLength += new BerLength().decode(is);
                        componentType = new TypeSpecification();
                        subCodeLength += componentType.decode(is, null);
                        if (subCodeLength == length.val) {
                            return codeLength;
                        }
                    }
                    throw new IOException("Unexpected end of sequence, length tag: " + length.val
                            + ", actual sequence length: " + subCodeLength);

                }

                public void encodeAndSave(int encodingSizeGuess) throws IOException {
                    BerByteArrayOutputStream os = new BerByteArrayOutputStream(encodingSizeGuess);
                    encode(os, false);
                    code = os.getArray();
                }

                @Override
                public String toString() {
                    StringBuilder sb = new StringBuilder("SEQUENCE{");
                    boolean firstSelectedElement = true;
                    if (componentName != null) {
                        sb.append("componentName: ").append(componentName);
                        firstSelectedElement = false;
                    }

                    if (!firstSelectedElement) {
                        sb.append(", ");
                    }
                    sb.append("componentType: ").append(componentType);

                    sb.append("}");
                    return sb.toString();
                }

            }

            public static final BerIdentifier identifier = new BerIdentifier(BerIdentifier.UNIVERSAL_CLASS,
                    BerIdentifier.CONSTRUCTED, 16);
            protected BerIdentifier id;

            public byte[] code = null;
            public List<SubSeq> seqOf = null;

            public SubSeqOf_components() {
                id = identifier;
                seqOf = new ArrayList<SubSeq>();
            }

            public SubSeqOf_components(byte[] code) {
                id = identifier;
                this.code = code;
            }

            public SubSeqOf_components(List<SubSeq> seqOf) {
                id = identifier;
                this.seqOf = seqOf;
            }

            public int encode(BerByteArrayOutputStream os, boolean explicit) throws IOException {
                int codeLength;

                if (code != null) {
                    codeLength = code.length;
                    for (int i = code.length - 1; i >= 0; i--) {
                        os.write(code[i]);
                    }
                }
                else {
                    codeLength = 0;
                    for (int i = (seqOf.size() - 1); i >= 0; i--) {
                        codeLength += seqOf.get(i).encode(os, true);
                    }

                    codeLength += BerLength.encodeLength(os, codeLength);

                }

                if (explicit) {
                    codeLength += id.encode(os);
                }

                return codeLength;
            }

            public int decode(InputStream is, boolean explicit) throws IOException {
                int codeLength = 0;
                int subCodeLength = 0;
                if (explicit) {
                    codeLength += id.decodeAndCheck(is);
                }

                BerLength length = new BerLength();
                codeLength += length.decode(is);

                while (subCodeLength < length.val) {
                    SubSeq element = new SubSeq();
                    subCodeLength += element.decode(is, true);
                    seqOf.add(element);
                }
                if (subCodeLength != length.val) {
                    throw new IOException("Decoded SequenceOf or SetOf has wrong length tag");

                }
                codeLength += subCodeLength;

                return codeLength;
            }

            public void encodeAndSave(int encodingSizeGuess) throws IOException {
                BerByteArrayOutputStream os = new BerByteArrayOutputStream(encodingSizeGuess);
                encode(os, false);
                code = os.getArray();
            }

            @Override
            public String toString() {
                StringBuilder sb = new StringBuilder("SEQUENCE OF{");

                if (seqOf == null) {
                    sb.append("null");
                }
                else {
                    Iterator<SubSeq> it = seqOf.iterator();
                    if (it.hasNext()) {
                        sb.append(it.next());
                        while (it.hasNext()) {
                            sb.append(", ").append(it.next());
                        }
                    }
                }

                sb.append("}");

                return sb.toString();
            }

        }

        public static final BerIdentifier identifier = new BerIdentifier(BerIdentifier.UNIVERSAL_CLASS,
                BerIdentifier.CONSTRUCTED, 16);
        protected BerIdentifier id;

        public byte[] code = null;
        public BerBoolean packed = null;

        public SubSeqOf_components components = null;

        public SubSeq_structure() {
            id = identifier;
        }

        public SubSeq_structure(byte[] code) {
            id = identifier;
            this.code = code;
        }

        public SubSeq_structure(BerBoolean packed, SubSeqOf_components components) {
            id = identifier;
            this.packed = packed;
            this.components = components;
        }

        public int encode(BerByteArrayOutputStream os, boolean explicit) throws IOException {

            int codeLength;

            if (code != null) {
                codeLength = code.length;
                for (int i = code.length - 1; i >= 0; i--) {
                    os.write(code[i]);
                }
            }
            else {
                codeLength = 0;
                codeLength += components.encode(os, false);
                // write tag: CONTEXT_CLASS, CONSTRUCTED, 1
                os.write(0xa1);
                codeLength += 1;

                if (packed != null) {
                    codeLength += packed.encode(os, false);
                    // write tag: CONTEXT_CLASS, PRIMITIVE, 0
                    os.write(0x80);
                    codeLength += 1;
                }

                codeLength += BerLength.encodeLength(os, codeLength);
            }

            if (explicit) {
                codeLength += id.encode(os);
            }

            return codeLength;

        }

        public int decode(InputStream is, boolean explicit) throws IOException {
            int codeLength = 0;
            int subCodeLength = 0;
            BerIdentifier berIdentifier = new BerIdentifier();

            if (explicit) {
                codeLength += id.decodeAndCheck(is);
            }

            BerLength length = new BerLength();
            codeLength += length.decode(is);

            codeLength += length.val;

            subCodeLength += berIdentifier.decode(is);
            if (berIdentifier.equals(BerIdentifier.CONTEXT_CLASS, BerIdentifier.PRIMITIVE, 0)) {
                packed = new BerBoolean();
                subCodeLength += packed.decode(is, false);
                subCodeLength += berIdentifier.decode(is);
            }

            if (berIdentifier.equals(BerIdentifier.CONTEXT_CLASS, BerIdentifier.CONSTRUCTED, 1)) {
                components = new SubSeqOf_components();
                subCodeLength += components.decode(is, false);
                if (subCodeLength == length.val) {
                    return codeLength;
                }
            }
            throw new IOException("Unexpected end of sequence, length tag: " + length.val + ", actual sequence length: "
                    + subCodeLength);

        }

        public void encodeAndSave(int encodingSizeGuess) throws IOException {
            BerByteArrayOutputStream os = new BerByteArrayOutputStream(encodingSizeGuess);
            encode(os, false);
            code = os.getArray();
        }

        @Override
        public String toString() {
            StringBuilder sb = new StringBuilder("SEQUENCE{");
            boolean firstSelectedElement = true;
            if (packed != null) {
                sb.append("packed: ").append(packed);
                firstSelectedElement = false;
            }

            if (!firstSelectedElement) {
                sb.append(", ");
            }
            sb.append("components: ").append(components);

            sb.append("}");
            return sb.toString();
        }

    }

    public static class SubSeq_floatingPoint {

        public static final BerIdentifier identifier = new BerIdentifier(BerIdentifier.UNIVERSAL_CLASS,
                BerIdentifier.CONSTRUCTED, 16);
        protected BerIdentifier id;

        public byte[] code = null;
        public Unsigned8 formatWidth = null;

        public Unsigned8 exponentWidth = null;

        public SubSeq_floatingPoint() {
            id = identifier;
        }

        public SubSeq_floatingPoint(byte[] code) {
            id = identifier;
            this.code = code;
        }

        public SubSeq_floatingPoint(Unsigned8 formatWidth, Unsigned8 exponentWidth) {
            id = identifier;
            this.formatWidth = formatWidth;
            this.exponentWidth = exponentWidth;
        }

        public int encode(BerByteArrayOutputStream os, boolean explicit) throws IOException {

            int codeLength;

            if (code != null) {
                codeLength = code.length;
                for (int i = code.length - 1; i >= 0; i--) {
                    os.write(code[i]);
                }
            }
            else {
                codeLength = 0;
                codeLength += exponentWidth.encode(os, true);

                codeLength += formatWidth.encode(os, true);

                codeLength += BerLength.encodeLength(os, codeLength);
            }

            if (explicit) {
                codeLength += id.encode(os);
            }

            return codeLength;

        }

        public int decode(InputStream is, boolean explicit) throws IOException {
            int codeLength = 0;
            int subCodeLength = 0;
            BerIdentifier berIdentifier = new BerIdentifier();

            if (explicit) {
                codeLength += id.decodeAndCheck(is);
            }

            BerLength length = new BerLength();
            codeLength += length.decode(is);

            codeLength += length.val;

            subCodeLength += berIdentifier.decode(is);
            if (berIdentifier.equals(BerInteger.identifier)) {
                formatWidth = new Unsigned8();
                subCodeLength += formatWidth.decode(is, false);
                subCodeLength += berIdentifier.decode(is);
            }
            else {
                throw new IOException("Identifier does not match the mandatory sequence element identifer.");
            }

            if (berIdentifier.equals(BerInteger.identifier)) {
                exponentWidth = new Unsigned8();
                subCodeLength += exponentWidth.decode(is, false);
                if (subCodeLength == length.val) {
                    return codeLength;
                }
            }
            throw new IOException("Unexpected end of sequence, length tag: " + length.val + ", actual sequence length: "
                    + subCodeLength);

        }

        public void encodeAndSave(int encodingSizeGuess) throws IOException {
            BerByteArrayOutputStream os = new BerByteArrayOutputStream(encodingSizeGuess);
            encode(os, false);
            code = os.getArray();
        }

        @Override
        public String toString() {
            StringBuilder sb = new StringBuilder("SEQUENCE{");
            sb.append("formatWidth: ").append(formatWidth);

            sb.append(", ");
            sb.append("exponentWidth: ").append(exponentWidth);

            sb.append("}");
            return sb.toString();
        }

    }

    public SubSeq_array array = null;

    public SubSeq_structure structure = null;

    public BerNull bool = null;

    public Integer32 bitString = null;

    public Unsigned8 integer = null;

    public Unsigned8 unsigned = null;

    public SubSeq_floatingPoint floatingPoint = null;

    public Integer32 octetString = null;

    public Integer32 visibleString = null;

    public BerBoolean binaryTime = null;

    public Integer32 mMSString = null;

    public BerNull utcTime = null;

    public TypeDescription() {
    }

    public TypeDescription(byte[] code) {
        this.code = code;
    }

    public TypeDescription(SubSeq_array array, SubSeq_structure structure, BerNull bool, Integer32 bitString,
            Unsigned8 integer, Unsigned8 unsigned, SubSeq_floatingPoint floatingPoint, Integer32 octetString,
            Integer32 visibleString, BerBoolean binaryTime, Integer32 mMSString, BerNull utcTime) {
        this.array = array;
        this.structure = structure;
        this.bool = bool;
        this.bitString = bitString;
        this.integer = integer;
        this.unsigned = unsigned;
        this.floatingPoint = floatingPoint;
        this.octetString = octetString;
        this.visibleString = visibleString;
        this.binaryTime = binaryTime;
        this.mMSString = mMSString;
        this.utcTime = utcTime;
    }

    public int encode(BerByteArrayOutputStream os, boolean explicit) throws IOException {
        if (code != null) {
            for (int i = code.length - 1; i >= 0; i--) {
                os.write(code[i]);
            }
            return code.length;

        }
        int codeLength = 0;
        if (utcTime != null) {
            codeLength += utcTime.encode(os, false);
            // write tag: CONTEXT_CLASS, PRIMITIVE, 17
            os.write(0x91);
            codeLength += 1;
            return codeLength;

        }

        if (mMSString != null) {
            codeLength += mMSString.encode(os, false);
            // write tag: CONTEXT_CLASS, PRIMITIVE, 16
            os.write(0x90);
            codeLength += 1;
            return codeLength;

        }

        if (binaryTime != null) {
            codeLength += binaryTime.encode(os, false);
            // write tag: CONTEXT_CLASS, PRIMITIVE, 12
            os.write(0x8c);
            codeLength += 1;
            return codeLength;

        }

        if (visibleString != null) {
            codeLength += visibleString.encode(os, false);
            // write tag: CONTEXT_CLASS, PRIMITIVE, 10
            os.write(0x8a);
            codeLength += 1;
            return codeLength;

        }

        if (octetString != null) {
            codeLength += octetString.encode(os, false);
            // write tag: CONTEXT_CLASS, PRIMITIVE, 9
            os.write(0x89);
            codeLength += 1;
            return codeLength;

        }

        if (floatingPoint != null) {
            codeLength += floatingPoint.encode(os, false);
            // write tag: CONTEXT_CLASS, CONSTRUCTED, 7
            os.write(0xa7);
            codeLength += 1;
            return codeLength;

        }

        if (unsigned != null) {
            codeLength += unsigned.encode(os, false);
            // write tag: CONTEXT_CLASS, PRIMITIVE, 6
            os.write(0x86);
            codeLength += 1;
            return codeLength;

        }

        if (integer != null) {
            codeLength += integer.encode(os, false);
            // write tag: CONTEXT_CLASS, PRIMITIVE, 5
            os.write(0x85);
            codeLength += 1;
            return codeLength;

        }

        if (bitString != null) {
            codeLength += bitString.encode(os, false);
            // write tag: CONTEXT_CLASS, PRIMITIVE, 4
            os.write(0x84);
            codeLength += 1;
            return codeLength;

        }

        if (bool != null) {
            codeLength += bool.encode(os, false);
            // write tag: CONTEXT_CLASS, PRIMITIVE, 3
            os.write(0x83);
            codeLength += 1;
            return codeLength;

        }

        if (structure != null) {
            codeLength += structure.encode(os, false);
            // write tag: CONTEXT_CLASS, CONSTRUCTED, 2
            os.write(0xa2);
            codeLength += 1;
            return codeLength;

        }

        if (array != null) {
            codeLength += array.encode(os, false);
            // write tag: CONTEXT_CLASS, CONSTRUCTED, 1
            os.write(0xa1);
            codeLength += 1;
            return codeLength;

        }

        throw new IOException("Error encoding BerChoice: No item in choice was selected.");
    }

    public int decode(InputStream is, BerIdentifier berIdentifier) throws IOException {
        int codeLength = 0;
        BerIdentifier passedIdentifier = berIdentifier;

        if (berIdentifier == null) {
            berIdentifier = new BerIdentifier();
            codeLength += berIdentifier.decode(is);
        }
        if (berIdentifier.equals(BerIdentifier.CONTEXT_CLASS, BerIdentifier.CONSTRUCTED, 1)) {
            array = new SubSeq_array();
            codeLength += array.decode(is, false);
            return codeLength;
        }

        if (berIdentifier.equals(BerIdentifier.CONTEXT_CLASS, BerIdentifier.CONSTRUCTED, 2)) {
            structure = new SubSeq_structure();
            codeLength += structure.decode(is, false);
            return codeLength;
        }

        if (berIdentifier.equals(BerIdentifier.CONTEXT_CLASS, BerIdentifier.PRIMITIVE, 3)) {
            bool = new BerNull();
            codeLength += bool.decode(is, false);
            return codeLength;
        }

        if (berIdentifier.equals(BerIdentifier.CONTEXT_CLASS, BerIdentifier.PRIMITIVE, 4)) {
            bitString = new Integer32();
            codeLength += bitString.decode(is, false);
            return codeLength;
        }

        if (berIdentifier.equals(BerIdentifier.CONTEXT_CLASS, BerIdentifier.PRIMITIVE, 5)) {
            integer = new Unsigned8();
            codeLength += integer.decode(is, false);
            return codeLength;
        }

        if (berIdentifier.equals(BerIdentifier.CONTEXT_CLASS, BerIdentifier.PRIMITIVE, 6)) {
            unsigned = new Unsigned8();
            codeLength += unsigned.decode(is, false);
            return codeLength;
        }

        if (berIdentifier.equals(BerIdentifier.CONTEXT_CLASS, BerIdentifier.CONSTRUCTED, 7)) {
            floatingPoint = new SubSeq_floatingPoint();
            codeLength += floatingPoint.decode(is, false);
            return codeLength;
        }

        if (berIdentifier.equals(BerIdentifier.CONTEXT_CLASS, BerIdentifier.PRIMITIVE, 9)) {
            octetString = new Integer32();
            codeLength += octetString.decode(is, false);
            return codeLength;
        }

        if (berIdentifier.equals(BerIdentifier.CONTEXT_CLASS, BerIdentifier.PRIMITIVE, 10)) {
            visibleString = new Integer32();
            codeLength += visibleString.decode(is, false);
            return codeLength;
        }

        if (berIdentifier.equals(BerIdentifier.CONTEXT_CLASS, BerIdentifier.PRIMITIVE, 12)) {
            binaryTime = new BerBoolean();
            codeLength += binaryTime.decode(is, false);
            return codeLength;
        }

        if (berIdentifier.equals(BerIdentifier.CONTEXT_CLASS, BerIdentifier.PRIMITIVE, 16)) {
            mMSString = new Integer32();
            codeLength += mMSString.decode(is, false);
            return codeLength;
        }

        if (berIdentifier.equals(BerIdentifier.CONTEXT_CLASS, BerIdentifier.PRIMITIVE, 17)) {
            utcTime = new BerNull();
            codeLength += utcTime.decode(is, false);
            return codeLength;
        }

        if (passedIdentifier != null) {
            return 0;
        }
        throw new IOException("Error decoding BerChoice: Identifier matched to no item.");
    }

    public void encodeAndSave(int encodingSizeGuess) throws IOException {
        BerByteArrayOutputStream os = new BerByteArrayOutputStream(encodingSizeGuess);
        encode(os, false);
        code = os.getArray();
    }

    @Override
    public String toString() {
        if (array != null) {
            return "CHOICE{array: " + array + "}";
        }

        if (structure != null) {
            return "CHOICE{structure: " + structure + "}";
        }

        if (bool != null) {
            return "CHOICE{bool: " + bool + "}";
        }

        if (bitString != null) {
            return "CHOICE{bitString: " + bitString + "}";
        }

        if (integer != null) {
            return "CHOICE{integer: " + integer + "}";
        }

        if (unsigned != null) {
            return "CHOICE{unsigned: " + unsigned + "}";
        }

        if (floatingPoint != null) {
            return "CHOICE{floatingPoint: " + floatingPoint + "}";
        }

        if (octetString != null) {
            return "CHOICE{octetString: " + octetString + "}";
        }

        if (visibleString != null) {
            return "CHOICE{visibleString: " + visibleString + "}";
        }

        if (binaryTime != null) {
            return "CHOICE{binaryTime: " + binaryTime + "}";
        }

        if (mMSString != null) {
            return "CHOICE{mMSString: " + mMSString + "}";
        }

        if (utcTime != null) {
            return "CHOICE{utcTime: " + utcTime + "}";
        }

        return "unknown";
    }

}
