/**
 * This class file was automatically generated by jASN1 v1.5.1-SNAPSHOT (http://www.openmuc.org)
 */

package org.openmuc.openiec61850.internal.mms.asn1;

import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.openmuc.jasn1.ber.BerByteArrayOutputStream;
import org.openmuc.jasn1.ber.BerIdentifier;
import org.openmuc.jasn1.ber.BerLength;

public class WriteRequest {

    public static class SubSeqOf_listOfData {

        public static final BerIdentifier identifier = new BerIdentifier(BerIdentifier.UNIVERSAL_CLASS,
                BerIdentifier.CONSTRUCTED, 16);
        protected BerIdentifier id;

        public byte[] code = null;
        public List<Data> seqOf = null;

        public SubSeqOf_listOfData() {
            id = identifier;
            seqOf = new ArrayList<Data>();
        }

        public SubSeqOf_listOfData(byte[] code) {
            id = identifier;
            this.code = code;
        }

        public SubSeqOf_listOfData(List<Data> seqOf) {
            id = identifier;
            this.seqOf = seqOf;
        }

        public int encode(BerByteArrayOutputStream os, boolean explicit) throws IOException {
            int codeLength;

            if (code != null) {
                codeLength = code.length;
                for (int i = code.length - 1; i >= 0; i--) {
                    os.write(code[i]);
                }
            }
            else {
                codeLength = 0;
                for (int i = (seqOf.size() - 1); i >= 0; i--) {
                    codeLength += seqOf.get(i).encode(os, true);
                }

                codeLength += BerLength.encodeLength(os, codeLength);

            }

            if (explicit) {
                codeLength += id.encode(os);
            }

            return codeLength;
        }

        public int decode(InputStream is, boolean explicit) throws IOException {
            int codeLength = 0;
            int subCodeLength = 0;
            if (explicit) {
                codeLength += id.decodeAndCheck(is);
            }

            BerLength length = new BerLength();
            codeLength += length.decode(is);

            while (subCodeLength < length.val) {
                Data element = new Data();
                subCodeLength += element.decode(is, null);
                seqOf.add(element);
            }
            if (subCodeLength != length.val) {
                throw new IOException("Decoded SequenceOf or SetOf has wrong length tag");

            }
            codeLength += subCodeLength;

            return codeLength;
        }

        public void encodeAndSave(int encodingSizeGuess) throws IOException {
            BerByteArrayOutputStream os = new BerByteArrayOutputStream(encodingSizeGuess);
            encode(os, false);
            code = os.getArray();
        }

        @Override
        public String toString() {
            StringBuilder sb = new StringBuilder("SEQUENCE OF{");

            if (seqOf == null) {
                sb.append("null");
            }
            else {
                Iterator<Data> it = seqOf.iterator();
                if (it.hasNext()) {
                    sb.append(it.next());
                    while (it.hasNext()) {
                        sb.append(", ").append(it.next());
                    }
                }
            }

            sb.append("}");

            return sb.toString();
        }

    }

    public static final BerIdentifier identifier = new BerIdentifier(BerIdentifier.UNIVERSAL_CLASS,
            BerIdentifier.CONSTRUCTED, 16);
    protected BerIdentifier id;

    public byte[] code = null;
    public VariableAccessSpecification variableAccessSpecification = null;

    public SubSeqOf_listOfData listOfData = null;

    public WriteRequest() {
        id = identifier;
    }

    public WriteRequest(byte[] code) {
        id = identifier;
        this.code = code;
    }

    public WriteRequest(VariableAccessSpecification variableAccessSpecification, SubSeqOf_listOfData listOfData) {
        id = identifier;
        this.variableAccessSpecification = variableAccessSpecification;
        this.listOfData = listOfData;
    }

    public int encode(BerByteArrayOutputStream os, boolean explicit) throws IOException {

        int codeLength;

        if (code != null) {
            codeLength = code.length;
            for (int i = code.length - 1; i >= 0; i--) {
                os.write(code[i]);
            }
        }
        else {
            codeLength = 0;
            codeLength += listOfData.encode(os, false);
            // write tag: CONTEXT_CLASS, CONSTRUCTED, 0
            os.write(0xa0);
            codeLength += 1;

            codeLength += variableAccessSpecification.encode(os, true);

            codeLength += BerLength.encodeLength(os, codeLength);
        }

        if (explicit) {
            codeLength += id.encode(os);
        }

        return codeLength;

    }

    public int decode(InputStream is, boolean explicit) throws IOException {
        int codeLength = 0;
        int subCodeLength = 0;
        BerIdentifier berIdentifier = new BerIdentifier();

        if (explicit) {
            codeLength += id.decodeAndCheck(is);
        }

        BerLength length = new BerLength();
        codeLength += length.decode(is);

        codeLength += length.val;

        subCodeLength += berIdentifier.decode(is);
        variableAccessSpecification = new VariableAccessSpecification();
        subCodeLength += variableAccessSpecification.decode(is, berIdentifier);
        subCodeLength += berIdentifier.decode(is);

        if (berIdentifier.equals(BerIdentifier.CONTEXT_CLASS, BerIdentifier.CONSTRUCTED, 0)) {
            listOfData = new SubSeqOf_listOfData();
            subCodeLength += listOfData.decode(is, false);
            if (subCodeLength == length.val) {
                return codeLength;
            }
        }
        throw new IOException(
                "Unexpected end of sequence, length tag: " + length.val + ", actual sequence length: " + subCodeLength);

    }

    public void encodeAndSave(int encodingSizeGuess) throws IOException {
        BerByteArrayOutputStream os = new BerByteArrayOutputStream(encodingSizeGuess);
        encode(os, false);
        code = os.getArray();
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder("SEQUENCE{");
        sb.append("variableAccessSpecification: ").append(variableAccessSpecification);

        sb.append(", ");
        sb.append("listOfData: ").append(listOfData);

        sb.append("}");
        return sb.toString();
    }

}
